// M parsing and indenting
// $Revision: 1.23 $  $Date: 2006/04/11 16:23:18Z $
// $Revision: $  $Date::                     $
#define M_INDENT  1 // this_cmd for m-indent command
//#define MATLABVERSION "1.1c Sep-15-2000"
//#define MATLABVERSION "1.1d Nov-27-2000"
//#define MATLABVERSION "1.1e Dec-08-2000"
//#define MATLABVERSION "1.1f Jan-09-2001"
//#define MATLABVERSION "1.1g Jan-19-2001"
//#define MATLABVERSION "1.1h Feb-02-2001"
//#define MATLABVERSION "1.1i Feb-14-2001"
//#define MATLABVERSION "1.1j Mar-19-2001"
//#define MATLABVERSION "1.1k Apr-04-2001"
//#define MATLABVERSION "1.1l Apr-07-2001"
//#define MATLABVERSION "1.1m May-12-2001"
//#define MATLABVERSION "1.1n May-22-2001"
//#define MATLABVERSION "1.1o Nov-8-2001"
//#define MATLABVERSION "1.1p Jan-31-2002"
//#define MATLABVERSION "1.1q Mar-14-2003"
//#define MATLABVERSION "1.1r Jul-23-2003" // Update to Eps12b7
//#define MATLABVERSION "1.1r Aug-13-2004" // Minor fix of end coloring
//#define MATLABVERSION "1.1s Feb-16-2005" // Fix init of menu
//#define MATLABVERSION "1.1t Apr-11-2006"   // Support for function/end and classdef
#define MATLABVERSION "1.1u Jul-04-2008"   // Fix a bug in comment flowing

char _m_mode_name[] = "MATLAB";
char matlab_version[24] = MATLABVERSION;
keytable m_tab;			/* key table for matlab mode */
keytable m_cx_tab;	/* Give matlab its own C-X prefix table */

user char m_tab_always_indents = 1;	// if 1, tab fixes indentation
          // from anywhere on line
user buffer short m_indent = 0;	// indent by this amt; 0 means use tab size
user short m_case_indent = 0; // indent level of case statement. If <0 takes m_indent
user char m_inline_ident = 1; // turn on or off indenting of inline comments 
user short m_comment_column = 40; // Trailing comments are put here 
user char m_comment_flow = 1; // <enter> after a comment starts new comment 
user char m_comment_delete_empty = 1; // <enter> clears comment if empty 
user char m_tag_elseif = 1; // should elseif xxx(yyy,'tagident') be tagged 
user char m_tag_case = 1; // should case 'tagident' be tagged 
user char m_tag_function = 1; // should function [x,y]=tagident(u,v) be tagged 
//user char m_tag_column = 0; // tag items in this column or before 
user char m_matchdelim = 1; // show matching delimiter for end statements 
user char m_want_bell  = 1; // ring bell on unmatched end statement 
user char m_mode_mouse_to_tag = 1; // double-click goes to tag - DOS only? 
user char m_auto_fill  = 1; // auto fills when entering comments 
user char m_auto_reindent  = 1; // re-indents on last 'd' or 'e' of end, else and case
user char m_auto_show_delimiters = 1; // turns off auto-show-delimiters
user char m_auto_show_delim_chars[10] = "{[()]}";
user char m_color_hanging_end_delimiters = 1; // apply special color class 
user char m_color_hanging_start_delimiters = 1; // apply special color class
user int m_color_hanging_key_extent = 10000; // # bytes around point to color hanging keywords
user int m_color_hanging_del_extent = 1000;  // # bytes around point to color hanging delimiters
user char m_color_unmatched_delimiters = 1; // apply special color class 
user char m_color_unterminated_strings = 1; // apply special color class 
user int reindent_after_matlab_yank = 10000;
user char m_auto_right_delim = 0; // insert a right delim when left is typed
user char m_auto_right_delim_chars[5] = "'{(["; // list of left delims for which to insert right
user char m_extra_keywords[100] = "";
user char m_auto_semicolon = 0; // insert a ';' after '=' when a new assignment is beginning
// new
user short m_short_complete = 0; // use the short form of identifier completion
user char m_add_objdirs_to_tag = 0;
user char m_strip_brackets = 0;
user char matlab_menu_file[80] = "tosctex.mnu";

//#define MAX_M_TAGINDENT 10

// Matlab mode color classes
color_class m_comment;         // % this is a comment
color_class m_keyword;         // for, if, else, end, global, ...
color_class m_function;        // a matlab function, e.g. inv(a)
color_class m_identifier;      // variable or object
color_class m_string;          // 'this is a string'
color_class m_number;          // 1.5e-10, Inf, Nan, end
color_class m_punctuation;     // =,*,-,^,.^,.*,[],(),{},;,:,etc
color_class m_unmatched_delim; // { without a }, ] without a [ etc
color_class m_unmatched_keyword; // for without an end, end without a for/while/if/try/switch
color_class m_unterminated;    // 'this is an unterminated string

int color_m_range();
int color_m_from_here();
